/* Sistemas Integrados TECNISA
   Compras e Suprimentos

Nome: 8060_CMPVIE_PREVCONGER.SQL

Descrio:
Agrupa a previso de consumo do planejamento alimentao industrial (PREVCONS)
e dos sistemas de comissaria (PREVCOMPRA), levando em consideracao as previses
de consumo e solicitaes das filiais para necessidade de compras.

Para aplicar
@C:\WIN_PRJ\SQL\ORACLE\8060_CMPVIE_PREVCONGER.SQL
@C:\WIN_V1.53\SQL\ORACLE\8060_CMPVIE_PREVCONGER.SQL

Criao:
23/02/99 - Yoris L. de Souza
*/

CREATE OR REPLACE
VIEW PREVCONGER AS
SELECT
   CDFILIAL,
   DTPREVCONS,
   CDPRODUTO,
   SUM(QTPRODCONS) AS QTPRODCONS
FROM
   (SELECT
       CDFILIAL,
       DTPREVCONS AS DTPREVCONS,
       CDPRODUTO,
       QTPREVCONS AS QTPRODCONS
    FROM
       PREVCONS
    UNION ALL
    SELECT
       CDFILIAL,
       DTPREVCOMP AS DTPREVCONS,
       CDPRODUTO,
       QTPRODCOMP AS QTPRODCONS
    FROM
       PREVCOMPRA
    UNION ALL
    SELECT
       PC.CDFILIAL,
       TRUNC(PV.DTPREVCONPDV) AS DTPREVCONS,
       PC.CDPRODUTO,
       SUM(PC.QTPRODCONPDV) AS QTPRODCONS
    FROM
       PREVCONSPDV PC,
       PREVISAOPDV PV
    WHERE
    	 (PC.CDFILIAL = PV.CDFILIAL) AND
       (PC.NRSEQPREVPDV = PV.NRSEQPREVPDV) AND
       (PC.CDPRODUTO <> PC.CDPRPAIPCPDV)
    GROUP BY
    	 PC.CDFILIAL,
       TRUNC(PV.DTPREVCONPDV),
       PC.CDPRODUTO

    UNION ALL
    SELECT
       CDFILIALCLIE,
       TRUNC(DTPREVENDVMN) AS DTPREVCONS,
       CDPRODUTO,
       QTSOLCONVMN AS QTPRODCONS
    FROM PREVCONSVMN
    UNION ALL
    SELECT
       FI.CDFILIAL,
       PC.DTPREVCONS AS DTPREVCONS,
       PC.CDPRODUTO,
       PC.QTPREVCONS AS QTPRODCONS
    FROM
       PREVCONS PC,
       FILINECE FI
    WHERE
       (FI.CDFILINECCMP = PC.CDFILIAL) AND
       (FI.IDSOLIPREV   = 'P')
    UNION ALL
    SELECT
       FI.CDFILIAL,
       PC.DTPREVCOMP AS DTPREVCONS,
       PC.CDPRODUTO,
       PC.QTPRODCOMP AS QTPRODCONS
    FROM
       PREVCOMPRA PC,
       FILINECE FI
    WHERE
       (FI.CDFILINECCMP = PC.CDFILIAL) AND
       (FI.IDSOLIPREV   = 'P')
    UNION ALL
    SELECT
       FI.CDFILIAL,
       TRUNC(PV.DTPREVCONPDV) AS DTPREVCONS,
       PC.CDPRODUTO,
       SUM(PC.QTPRODCONPDV) AS QTPRODCONS
    FROM
       PREVCONSPDV PC,
       PREVISAOPDV PV,
       FILINECE FI
    WHERE
    	 (PC.CDFILIAL = PV.CDFILIAL) AND
       (PC.NRSEQPREVPDV = PV.NRSEQPREVPDV) AND
       (PC.CDPRODUTO <> PC.CDPRPAIPCPDV) AND
       (FI.CDFILINECCMP = PC.CDFILIAL) AND
       (FI.IDSOLIPREV   = 'P')
    GROUP BY
    	 FI.CDFILIAL,
       TRUNC(PV.DTPREVCONPDV),
       PC.CDPRODUTO
    UNION ALL
    SELECT
       FI.CDFILIAL,
       TRUNC(PC.DTPREVENDVMN) AS DTPREVCONS,
       PC.CDPRODUTO,
       PC.QTSOLCONVMN AS QTPRODCONS
    FROM
       PREVCONSVMN PC,
       FILINECE FI
    WHERE
       (FI.CDFILINECCMP = PC.CDFILIALCLIE) AND
       (FI.IDSOLIPREV   = 'P')
    UNION ALL
    SELECT
       FI.CDFILIAL,
       IT.DTPROGENTR                 AS DTPREVCONS,
       PR.CDPRODESTO                 AS CDPRODUTO,
       IT.QTSOLIPROD * PR.VRFATOCONV AS QTPRODCONS
    FROM
       ITEMSOLI IT,
       PRODUTO PR,
       FILINECE FI
    WHERE
       (FI.CDFILINECCMP = IT.CDFILSOLI) AND
       (FI.IDSOLIPREV  <> 'P')          AND
       (IT.CDPRODUTO    = PR.CDPRODUTO)
    UNION ALL
    SELECT
       ITPREVCOMP.CDFILIAL,
       TRUNC(ITPREVCOMP.DTENTPRECOMP) AS DTPREVCONS,
       ITPREVCOMP.CDPRODUTO,
       ITPREVCOMP.QTPREVCOMP AS QTPRODCONS
    FROM
       ITPREVCOMP
    WHERE
       ITPREVCOMP.IDSTITPRCOMP = 'A')
GROUP BY
   CDFILIAL,
   DTPREVCONS,
   CDPRODUTO
/